//This header defines a parameters namespace for specifying global parameters for the algorithm
#pragma once
#include <string>

namespace parameters {
	//General Parameters
	const int  n = 7;
	const int  maxIntensity = 255;
	const int  M = 4;
	const bool renderFeatureNumbers = false;
	
	//Optimization Parameters
	const int    minStepsTopLevel = 15;
	const int    maxStepsTopLevel = 40;
	const int    minStepsLowerLevels = 5;
	const int    maxStepsLowerLevels = 40;
	const double AverageTolerance = 0.0;
	const double AbsoluteTolerance = 0.0;
	const double DerivativeTolerance = 0.00001;
	
	//Feature Management Parameters (For management mode 0)
	const int    numberOfFeatures = 35;
	const int    newFeatureEdgeRadius = 100;
	const double oldFeatureEdgeRadius = ((n+1)/2)*pow(2.0,(float)(M-1)) + 5.0;
	const float  minFeatureScore = 0.0;//0.00001;
	const int    extensiveFeatureReviewPeriod = 0; //Number of frames between exhaustive reviews: 0 means do not perform exhaustive reviews
	const int    numberOfTopFeaturesThatMustBeTracked = 10; //We require that the best (this many) features be among those tracked
	const float  identificationTolerance = 3.0; //If we are tracking a feature within this many pixels of a desired feature, we say the desired feature is already being tracked.
};
